{# heredando header y footer #}
{% extends "./plantilla.html" %}
{% load static %}
  {% block contenido %}

    <br>
    <div class="container-fluid py-4">
      <div class="row">
        <div class="col-xl-2 col-sm-6 mb-xl-0 mb-9">
        </div>
        <div class="col-xl-10 col-sm-6 mb-xl-0 mb-9">
          <h3>REGISTRO DE ASIGNATURAS</h3>
          <br>
          <form class="" action="/guardarAsignatura/" method="post" enctype="multipart/form-data" id='frm_nuevo_asignatura'>
            {% csrf_token %}
            <div class="row">
              <div class="col-md-6">
                <b>SELECCIONE EL CURSO:</b>
                <select  name="id_curso"  id="id_curso"  class="selectpicker" data-live-search="true" data-live-search-style="startsWith" required>
                  <option value="">-- Seleccione el curso --</option>
                  {% for curso in cursos %}
                  <option value="{{curso.idCursoGEPT}}">{{curso.nivelCursoGEPT}}</option>
                  {% endfor %}
                </select>
                <br>
                <br>
                <b>NOMBRE:</b>
                <input type="text" name="nombreAsignaturaGEPT" id="nombreAsignaturaGEPT" value="" placeholder="Ingrese el nombre de la Asignatura" class="form-control" required>
                <br>
                <b>CREDITOS:</b>
                <input type="number" name="creditosAsignaturaGEPT" id="creditosAsignaturaGEPT" value="" placeholder="Ingrese los creditos" class="form-control" required>
                <br>
                <b>HORAS SEMANALES:</b>
                <input type="text" name="horaSemanalAsignaturaGEPT" id="horaSemanalAsignaturaGEPT" value="" placeholder="Ingrese el Profesor" class="form-control" required>
                <br>
                <b>SEMESTRE:</b>
                <input type="text" name="semestreAsignaturaGEPT" id="semestreAsignaturaGEPT" value="" placeholder="Ingrese el Profesor" class="form-control" required>
                <br>
                <b>FECHA DE INICIO:</b>
                <input type="date" name="fechaInicioAsignaturaGEPT" id="fechaInicioAsignaturaGEPT" value="" placeholder="Ingrese la fecha de inicio" class="form-control" required>
                <br>
                <b>FECHA DE FINALIZACIÓN:</b>
                <input type="date" name="fechaFinalizacionAsignaturaGEPT" id="fechaFinalizacionAsignaturaGEPT" value="" placeholder="Ingrese la fecha de finalizacion" class="form-control" required>
                <br>
                <br>
              </div>
              <div class="col-md-6">
                <b>PROFESOR:</b>
                <input type="text" name="profesorAsignaturaGEPT" id="profesorAsignaturaGEPT" value="" placeholder="Ingrese el Profesor" class="form-control" required>
                <br>
                <b>SILABO:</b>
                <input type="file" accept="application/pdf" name="silaboAsignaturaGEPT" id="silaboAsignaturaGEPT" value="" placeholder="Ingrese el silabo" class="form-control" required>
                <br>
              </div>
            </div>
            <center>
              <button type="submit" name="button" class="btn btn-info bg-gradient-info">Guardar</button>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
              <a type="reset" name="button" class="btn btn-danger bg-gradient-danger" href="{% url 'listadoAsignaturas' %}">Cancelar</a>
            </center>
          </form>
          <hr>
        <div class="col-md-12">
          <table class="table table-striped" id="tbl_asignatura" style="color: black;">
            <h3>LISTADO DE CURSOS</h3>
            <div class="d-flex justify-content-center" >
              <img src="{% static 'img/4.jpg' %}" alt="" class="img-fluid">
            </div>
            <thead>
              <tr>
                <th>ID</th>
                <th>NIVEL</th>
                <th>NOMBRE</th>
                <th>CREDITOS</th>
                <th>FECHA INICIO</th>
                <th>FECHA FINALIZACIÓN</th>
                <th>PROFESOR</th>
                <th>SILABO</th>
                <th>HORAS SEMANALES</th>
                <th>SEMESTRE</th>
                <th>ACCIONES</th>
              </tr>
            </thead>
            <tbody>
              {% for asignatura in asignaturas %}
                <tr>
                  <td>{{asignatura.idAsignaturaGEPT}}</td>
                  <td>{{asignatura.curso.nivelCursoGEPT}}</td>
                  <td>{{asignatura.nombreAsignaturaGEPT}}</td>
                  <td>{{asignatura.creditosAsignaturaGEPT}}</td>
                  <td>{{asignatura.fechaInicioAsignaturaGEPT}}</td>
                  <td>{{asignatura.fechaFinalizacionAsignaturaGEPT}}</td>
                  <td>{{asignatura.profesorAsignaturaGEPT}}</td>
                  <td>
                  {% if asignatura.silaboAsignaturaGEPT %}
                    <a href="{{asignatura.silaboAsignaturaGEPT.url}}" target="_blank">VER PDF</a>
                  {% else %}
                    <b>N/A</b>
                  {% endif %}
                </td>
                  <td>{{asignatura.horaSemanalAsignaturaGEPT}}</td>
                  <td>{{asignatura.semestreAsignaturaGEPT}}</td>
                  <td>
                    <a href="/editarAsignatura/{{asignatura.idAsignaturaGEPT}}" class="btn btn-warning bg-gradient-warning">Editar</a>
                    <a href="javascript:void(0)" class="btn btn-danger bg-gradient-danger" onclick="eliminarAsignatura('/eliminarAsignatura/{{asignatura.idAsignaturaGEPT}}');">Eliminar</a>
                  </td>
                </tr>
                {% endfor %}
            </tbody>
          </table>
          <button id="toggleChartButton" onclick="toggleChart()" class="btn btn-info bg-gradient-info">Mostrar/ocultar gráfico</button>
        </div>
      </div>
    </div>
  </div>
    <script type="text/javascript">
      function eliminarAsignatura(url){
        iziToast.question({
            timeout: 15000,
            close: true,
            overlay: true,
            displayMode: 'once',
            id: 'question',
            zindex: 999,
            title: 'CONFIRMACIÓN',
            message: '¿Está seguro de eliminar la Asignatura seleccionada?',
            position: 'center',
            buttons: [
                ['<button><b>SI</b></button>', function (instance, toast) {
                    instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
                    window.location.href=url;
                }, true],
                ['<button>NO</button>', function (instance, toast) {

                    instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');

                }],
            ]
        });
      }
    </script>
    <script type="text/javascript">
      $(document).ready(function() {
        $("#frm_nuevo_asignatura").validate({
          rules: {
            "id_curso": {
              required: true
            },
            "nombreAsignaturaGEPT": {
              required: true,
              lettersOnly: true
            },
            "creditosAsignaturaGEPT": {
              required: true
            },
            "fechaInicioAsignaturaGEPT": {
              required: true
            },
            "fechaFinalizacionAsignaturaGEPT": {
              required: true
            },
            "profesorAsignaturaGEPT": {
              required: true,
              lettersOnly: true
            },
            "silaboAsignaturaGEPT": {
              required: true
            },
            "horaSemanalAsignaturaGEPT": {
              required: true
            },
            "semestreAsignaturaGEPT": {
              required: true
            }
          },
          messages: {
            "id_curso": {
              required: "Debe seleccionar un curso"
            },
            "nombreAsignaturaGEPT": {
              required: "Debe ingresar el nombre de la asignatura",
              lettersOnly: "Ingrese solo letras"
            },
            "creditosAsignaturaGEPT": {
              required: "Debe ingresar los créditos de la asignatura"
            },
            "fechaInicioAsignaturaGEPT": {
              required: "Debe ingresar la fecha de inicio"
            },
            "fechaFinalizacionAsignaturaGEPT": {
              required: "Debe ingresar la fecha de finalización"
            },
            "profesorAsignaturaGEPT": {
              required: "Debe ingresar el nombre del profesor",
              lettersOnly: "Ingrese solo letras"
            },
            "silaboAsignaturaGEPT": {
              required: "Debe ingresar el sílabo"
            },
            "horaSemanalAsignaturaGEPT": {
              required: "Debe ingresar el número de horas a la semana"
            },
            "semestreAsignaturaGEPT": {
              required: "Debe ingresar el semestre de la asignatura"
            }
          }
        });

        // Agregar regla de método personalizado para letras solo
        $.validator.addMethod("lettersOnly", function(value, element) {
          return this.optional(element) || /^[a-zA-Z\s]+$/.test(value);
        }, "Ingrese solo letras");
      });
    </script>

    <script type="text/javascript">
       //let table = new DataTable('#tbl_clientes');
       $(document).ready(function() {
           $('#tbl_asignatura').DataTable({
               dom: 'Bfrtip',
               language: {
                 url: '//cdn.datatables.net/plug-ins/1.13.7/i18n/es-ES.json',
               },
               buttons: [
                   {
                       extend: 'pdfHtml5',
                       text: '<i class="fa fa-file-pdf-o"></i> PDF',
                       titleAttr: 'Exportar a PDF',
                       className: 'btn btn-danger bg-gradient-danger', // Clase de estilo para el botón
                       title: 'LISTADO DE LAS ASIGNATURAS'
                   },
                   {
                       extend: 'print',
                       text: '<i class="fa fa-print"></i> Imprimir',
                       titleAttr: 'Imprimir',
                       className: 'btn btn-primary bg-gradient-prymary', // Clase de estilo para el botón
                       title: 'LISTADO DE LAS ASIGNATURAS'
                   },
                   {
                       extend: 'csv',
                       text: '<i class="fa fa-file-text-o"></i> CSV',
                       titleAttr: 'Exportar a CSV',
                       className: 'btn btn-success bg-gradient-success' // Clase de estilo para el botón
                   }
               ]
           });
       });
      </script>
      <script>
        $(document).ready(function () {
            $("#silaboAsignaturaGEPT").fileinput({
              //showUpload:false
              //showRemove: false,
              language:'es',
            });
        });
      </script>

      <div id="chartContainer" style="width: 50%; margin: auto; border: 2px solid black; padding: 10px; display: none;">
        <canvas id="myChart"></canvas>
      </div>

      <script>
          document.addEventListener('DOMContentLoaded', function () {
            const ctx = document.getElementById('myChart');

            const cursosSet = new Set();

            const asignaturasCurso = {};
            {% for asignatura in asignaturas %}
              cursosSet.add("{{ asignatura.curso.nivelCursoGEPT }}");
              if (!asignaturasCurso["{{ asignatura.curso.nivelCursoGEPT }}"]) {
                asignaturasCurso["{{ asignatura.curso.nivelCursoGEPT }}"] = 1;
              } else {
                asignaturasCurso["{{ asignatura.curso.nivelCursoGEPT }}"] += 1;
              }
            {% endfor %}
            const cursosArray = Array.from(cursosSet);
            const posiciones = cursosArray.map((curso, index) => ({ x: index, y: asignaturasCurso[curso] || 0 }));

            new Chart(ctx, {
              type: 'bar',
              data: {
                labels: cursosArray,
                datasets: [{
                  label: 'Cantidad de Niveles',
                  data: posiciones.map(posicion => posicion.y),
                  backgroundColor: 'rgba(248, 68, 68)',
                  borderColor: 'rgba(248, 68, 68)',
                  borderWidth: 1,
                }]
              },
              options: {
                scales: {
                  x: {
                    type: 'category',
                    position: 'bottom',
                  },
                  y: {
                    beginAtZero: true,
                    max: 10,
                    stepSize: 1,
                  }
                }
              }
            });
            window.toggleChart = function() {
              const chartContainer = document.getElementById('chartContainer');

              if (chartContainer.style.display === 'none') {
                chartContainer.style.display = 'block';
              } else {
                chartContainer.style.display = 'none';
              }
            };
          });

      </script>
  {% endblock %}
